#Creating various plots and calculation of key results for white ash analysis


	#########################
	#--- PLOTTING ---		#
	#########################

setwd("C:/Users/shoban.DESKTOP-DLPV5IJ/Dropbox/Projects/Fant_USFS_white_ash/")
setwd("/home/user/Dropbox/Projects/Fant_USFS_white_ash/")

load(file="summ_results.R");	load("params_run.Rda")
list_allele_cat<-c("global","glob_v_com","glob_com","glob_lowfr","glob_rare","reg_rare","loc_com_d1","loc_com_d2","loc_rare")
	
#optional if proportions
for (n in 1:num_reps) summ_results[,3:11,1,n]<-t(t(summ_results[,3:11,1,n])/summ_results[length(summ_results[,1,1,1]),3:11,1,n])	

#mean across reps
all_mean<-apply(summ_results[,,1,1:100000],c(1,2),mean)

#!!!RESULT!!!- HOW MANY ALLELES ARE CAUGHT IN EACH CATEGORY FOR THE TREATED CATEGORY
all_mean[192,]
# 274  			10   0.977   1.00   1.00   1.00   0.948   1.00  	1.00  	 1.00   0.956
			
#!!!RESULT!!!- HOW MANY ALLELES IF NUMBER TREES CUT IN HALF, STILL 10 POPULATIONS
all_mean[188,]
# 140.60428  	10 	0.811 	1.00 	0.999 	0.986 	0.585	1.00 	0.980 	0.973	 0.643


	
	############################################################
	#LOOKING AT CHOICE OF 4 POPULATIONS OR 10 POPULATIONS
	############################################################

#Specific reduction in number of populations	
#Look at 5 populations and 10 populations with equal numbers of individuals
all_mean[c(95,179),]
#Look at 4 populations and 10 populations with equal numbers of individuals
all_mean[c(76,177),]
#						all			very common	common		low freq	rare		locally common	locally common	locally rare
#[1,]	61.40178	4	0.6440495	0.9997221	0.9944345	0.8477916	0.3142697	0.80249			0.754585		0.3857404
#[2,]	61.76985	10	0.6659492	0.9999989	0.9994161	0.911432	0.3142231	0.9019267		0.8839763		0.3911749
#						0.0218997	0.0002768	0.0049816	0.0636404	-4.66E-05	0.0994367		0.1293913		0.0054345

			
	############################
#PLOT FOR 4 VS 10 BUT NOT USED FOR PUBLICATION
pdf(file="comp4v10.pdf")
comp4<-apply(summ_results[(summ_results[,2,1,1]==4),,1,1:num_reps],c(1,2),mean)[-20,]
#removing 20 and 21 because the treated samples line has 10 populations 
#but is not one of the comparisons we want here
comp10<-apply(summ_results[(summ_results[,2,1,1]==10),,1,1:num_reps],c(1,2),mean)[-(20:21),]
for (foc_all in c(3,6,7,10)){
	plot(comp10[,foc_all]~comp10[,1],xlim=c(10,100),ylim=c(min(comp4[,foc_all]),max(comp10[,foc_all])),pch="", xlab="number of trees total", ylab="proportion of genetic variation preserved", main=list_allele_cat[foc_all-2])
	lines(comp10[,foc_all]~comp10[,1],lty=1,lwd=2); lines(comp4[,foc_all]~comp4[,1],lty=2,lwd=2)
	legend(60,0.5,legend=c("sampling 10 populations", "sampling 4 populations"),lty=c(1,2),lwd=c(2,2))
}
dev.off()

	
	
	##############################################################
	#plots for the CHOICE OF ADDING MORE TREES OR MORE POPULATIONS
	############################################################
	
#This first one makes a PDF of the tradeoff for each of the allele categories, NOT FOR PUB
pdf(file="trees_v_pops.pdf",width=6.5, height=4.5)
all_mean_this<-list()
for (foc_all in 3:11){
	#transform the columns from all_mean
	#into a matrix all_mean_this with rows for plants and columns for pops
	all_mean_this<-matrix(all_mean[1:(length(n_pops_samp)*length(n_trees_samp)),foc_all],nrow=l_plt_smp,dimnames=list(n_trees_samp,n_pops_samp))/all_mean[ dim(all_mean)[1],foc_all]
	par(mfrow=c(1,2),mar=c(5,4,2,1))
		plot(all_mean_this[1,]~colnames(all_mean_this),type="l",xlim=c(1,11.5),ylim=c(0.1,1),xlab="number of populations",ylab="proportion of genetic variation")
		for (t in n_trees_samp) lines(all_mean_this[t-1,]~colnames(all_mean_this))
		for (tree_index in c(1,2,4,6,9,14,19)) text(11,all_mean_this[tree_index,10],n_trees_samp[tree_index],cex=.9)
		axis(4, at= c(0,.2,.4,.6,.8,1), labels=F)
		text(7,.2,"numbered lines signify", cex=.9); text(7,.15,"number of trees per population", cex=.8)
	par(mar=c(5,1,2,4))
		plot(all_mean_this[,1]~rownames(all_mean_this),type="l",xlim=c(2,22.5),ylim=c(0.1,1),yaxt="n",xlab="number of trees")
		axis(4, at= c(0,.2,.4,.6,.8,1), labels=T); 	axis(2, at= c(0,.2,.4,.6,.8,1), labels=F)
		for (p in n_pops_samp) lines(all_mean_this[,p]~rownames(all_mean_this),col="black")
		for (pop_index in c(1,2,4,6,8,10)) text(21.5,all_mean_this[19,pop_index],n_pops_samp[pop_index],cex=.9)
		text(14,.2,"numbered lines signify", cex=.9); text(14,.15,"number of populations", cex=.8)
}
dev.off()

#This one makes a PDF of the tradeoff between pops and trees for just all alleles (global) and locally common,
# next to each other (thus four graphs), FOR PUBLICATION
pdf(file="trees_v_pops_for_pub.pdf",width=8.5, height=3)
all_mean_this<-list()
all_mean_this<-matrix(all_mean[1:(length(n_pops_samp)*length(n_trees_samp)),3],nrow=l_plt_smp,dimnames=list(n_trees_samp,n_pops_samp))/all_mean[ dim(all_mean)[1],3]
par(mfrow=c(1,4),mar=c(5,4,0,1), oma=c(0,1,2,0))	
	plot(all_mean_this[1,]~colnames(all_mean_this),type="l",xlim=c(1,11.5),ylim=c(0,1),xlab="number of populations",ylab="proportion of genetic variation",cex.lab=1.2);	for (t in n_trees_samp) lines(all_mean_this[t-1,]~colnames(all_mean_this));	for (tree_index in c(1,2,4,6,9,14,19)) text(11,all_mean_this[tree_index,10],n_trees_samp[tree_index],cex=.9);	axis(4, at= c(0,.2,.4,.6,.8,1), labels=F);	text(6,.1,"numbered lines signify", cex=.9); text(6,.05,"number of trees per population", cex=.9);	par(mar=c(5,1,0,4))
	plot(all_mean_this[,1]~rownames(all_mean_this),type="l",xlim=c(2,22.5),ylim=c(0,1),yaxt="n",xlab="number of trees",cex.lab=1.2);	axis(4, at= c(0,.2,.4,.6,.8,1), labels=F); 	axis(2, at= c(0,.2,.4,.6,.8,1), labels=F);	for (p in n_pops_samp) lines(all_mean_this[,p]~rownames(all_mean_this),col="black");	for (pop_index in c(1,2,4,6,8,10)) text(21.5,all_mean_this[19,pop_index],n_pops_samp[pop_index],cex=.9);	text(14,.1,"numbered lines signify", cex=.9); text(14,.05,"number of populations", cex=.9);	par(mar=c(5,4,0,1))
	
all_mean_this<-matrix(all_mean[1:(length(n_pops_samp)*length(n_trees_samp)),10],nrow=l_plt_smp,dimnames=list(n_trees_samp,n_pops_samp))/all_mean[ dim(all_mean)[1],10]
	plot(all_mean_this[1,]~colnames(all_mean_this),type="l",xlim=c(1,11.5),ylim=c(0,1),xlab="number of populations",ylab="proportion of genetic variation",cex.lab=1.2);	for (t in n_trees_samp) lines(all_mean_this[t-1,]~colnames(all_mean_this));	for (tree_index in c(1,2,4,6,9,19)) text(11,all_mean_this[tree_index,10],n_trees_samp[tree_index],cex=.9);	axis(4, at= c(0,.2,.4,.6,.8,1), labels=F);	text(6,.1,"numbered lines signify", cex=.9); text(6,.05,"number of trees per population", cex=.9);	par(mar=c(5,1,0,4))
	plot(all_mean_this[,1]~rownames(all_mean_this),type="l",xlim=c(2,22.5),ylim=c(0,1),yaxt="n",xlab="number of trees",cex.lab=1.2);	axis(4, at= c(0,.2,.4,.6,.8,1), labels=F); 	axis(2, at= c(0,.2,.4,.6,.8,1), labels=F);	for (p in n_pops_samp) lines(all_mean_this[,p]~rownames(all_mean_this),col="black");	for (pop_index in c(1,2,4,6,10)) text(21.5,all_mean_this[19,pop_index],n_pops_samp[pop_index],cex=.9);	text(14,.1,"numbered lines signify", cex=.9); text(14,.05,"number of populations", cex=.9)
	mtext("global alleles                                                                           locally common alleles",side=3,line=.5,outer=T, cex=.8)
dev.off()
	
#!!!RESULT!!! EXAMPLE EQUIVALENCY BETWEEN MORE TREES OR MORE POPULATIONS SAME LOCALLY COMMON ALLELES
all_mean[c(132,179),c(1,2,10)]
#[1,] 102.88942    7 0.9151425
#[2,]  77.06595   10 0.9146412

	
	
	###################################################	
	#PLOT OF WHICH POPULATIONS ARE BEST- HISTOGRAM
	
#is it the same best combo throughout?  To have a look at the names of these top pops
	#POPS_a[[3]][seq(5,190,5)]
#to see how often certain populations are showing up
	#sort(table(unlist(POPS_a[[3]][seq(5,190,5)]))); sort(table(unlist(POPS_a[[3]][seq(110,190,5)])))

load(file="POPS_a.R"); load("params_run.Rda")

#This will go through each allele type as the optimality criteria
#each number of populations (1:10) and find which populations occur most common as "best"
#for (l in 3:length(POPS_a)) for (w in 1:length(POPS_a[[3]])) POPS_a[[l]][[w]]<-sort(POPS_a[[l]][[w]])
#lapply(POPS_a[[6]], write, file="test.csv",append=T,ncolumns=20)
	#RESULT IN PAPER IS PLOT 3 AND 10
for (a in 3:11){
	pdf(file=paste("most_chosen_pops_a_",a,".pdf"), height=6, width=8)
	for (p in 1:(max_num_pops+1)) {
		pops_freq<-unlist(POPS_a[[a]][(p*19-18):(p*19)])
		if (p==(max_num_pops+1)) pops_freq<-unlist(POPS_a[[a]])
		hist(pops_freq, xlab="population number", ylab="frequency with which that population was chosen",cex.axis=.8,breaks=0:17,xaxt="n")
		axis(side=1,labels=c(5,6,25,26,87,88,103,104,126,142,149,150,158,162,166,186,200), at=0.5:16.5, cex.axis=.8)
	}
	dev.off()
}

	###################################################	
	#PLOT OF WHICH POPULATIONS ARE BEST- HISTOGRAM WITH SMALL NUMBERS OF SAMPLES
	
#this limits the histogram to working on sampling with number of trees less than 3 (one of the smaller pop'ns)
#shows that the similar populations are chosen for these smaller tree numbers
sm_pop_freq<-list()
for (i in 0:9) sm_pop_freq[[i+1]]<-(1:3+19*i)
pdf(file=paste("most_chosen_pops_a_3_limit_3_trees.pdf"), height=6, width=8)
hist(unlist(POPS_a[[3]][unlist(sm_pop_freq)]), xlab="population number", ylab="frequency with which that population was chosen",cex.axis=.8,breaks=0:17,xaxt="n")
	axis(side=1,labels=c(5,6,25,26,87,88,103,104,126,142,149,150,158,162,166,186,200), at=0.5:16.5, cex.axis=.8)
dev.off()
	
	
	
	
	#####################################################
	#--VERIFYING THE BEST COMBINATIONS --#
	####################################################
	
#This is the actual comparison- the PROOF that sampling these best populations does get more diversity than average sampling
#To do that we will plot comparing summ_results to summ_results_(allele_number)

#First focus on "best" populations chosen based on allele 3 as ranking criteria
#and see how much better  this does over a random sampling
#ALTERNATE ANALYSIS To check out the "best" populations improvement using other alleles as the criteria, 
#just change the "3" in summ_results_3top1 to 4 through 11, recalling alleles are numbered 3 through 11,
#And then change any indexing below that refers to allele category 3
load(file="summ_results.R")
num_reps<-length(summ_results[,1,1,1])
for (n in 1:num_reps) summ_results[,3:11,1,n]<-t(t(summ_results[,3:11,1,n])/summ_results[length(summ_results[,1,1,1]),3:11,1,n])
load(file="Dec4_100K_main_results/summ_results_3top1.R")
summ_results[191:193,2,1,]<-0; summ_results_2[191:193,2,1,]<-0
all_mean<-apply(summ_results[,,1,1:num_reps],c(1,2),mean); all_mean_2<-apply(summ_results_2[,,1,1:num_reps],c(1,2),mean)
	
	###################################################	
	#PLOT FOR IMPROVEMENT BY OPTIMALITY FOR EACH ALLELE CAT (BOXPLOTS)- NOT USED IN PUBLICATION
	
	#This plot compares the diversity captured in the best sampling to on average, for each allele category
	#looking at compare, just basing it off the global alleles helps almost all the allele categories
	#max really does a lot better- there are some best combos!
pdf(file="boxplot_diff_best_random_by_allele_cat.pdf")
compare<-array(dim=dim(all_mean))
	for (foc_all in 3:11)
		for (i in 1:length(compare[,1])) compare[i,foc_all]<-(all_mean[i,foc_all]-all_mean_2[i,foc_all])
	boxplot(compare, main=c("test",foc_all),main=list_allele_cat[foc_all-2])
	abline(h=0,col="red",lty=2)
dev.off()

			#!!!RESULT!!! GAINS FROM TREATING OPTIMAL SET
#how much better is optimal choice, for various categories (all, common, low freq, rare, locally common 2) 
mean(compare[,3],na.rm=T); min(compare[,3],na.rm=T) 	#0.0768 and 0.161	
#if run "one of top 5" 0.0757 and 0.156 slightly less- not mentioned in paper
mean(compare[,5],na.rm=T); min(compare[,5],na.rm=T)		#0.0145 and 0.117
mean(compare[,6],na.rm=T); min(compare[,6],na.rm=T) 	#0.0590 and 0.181
mean(compare[,7],na.rm=T); min(compare[,7],na.rm=T) 	#0.1173 and 0.312
mean(compare[,10],na.rm=T); min(compare[,10],na.rm=T) 	#0.0358 and 0.238

#LOOK AT NUMBERS FOR SPECIFIC EXAMPLES
#!!!RESULT!!! THIS ONE USED IN PAPER TO CALCULATE 21% FEWER TREES
all_mean[190,c(1:5,10)]; all_mean_2[184,c(1:5,10)]
	#[190,] 152.9   10 0.8303208 1.0000000 1.0000000 0.97733161
	#[184,]  121   10 0.8296088 1.0000000 1.0000000 0.99287565
#THIS ONE NOT USED BUT IS 23% FEWER TREES
all_mean[91,c(1:5,10)]; all_mean_2[85,c(1:5,10)]
	# [85,]   50    5 0.6762251 1.0000000 0.9993182 0.79145078
	#[91,]  64.9    5 0.6558557 1.0000000 0.9968639 0.79468912	
#Others can be explored here
all_mean[,c(1:5,10)]; all_mean_2[,c(1:5,10)]

	###################################################	
	#PLOT FOR IMPROVEMENT FOR EACH NUMBER OF TREES, LONG BOXPLOT- NOT USED IN PUBLICATION
	
#This plot goes into more detail, focusing on allele cat 3 (global)
#And makes a plot for each number of chosen populations (1:10)
#And within each plot will make a set of boxplots for each number of trees chosen to show its always better
#on the bottom is printed the number of trees sampled under best vs. random- usually more for best but not always
foc_all<-3
pdf(file=paste("boxplots_best_random_by_tree.pdf"), width=12,height=6)
for (pop in 1:10){
	these_rows<-which(summ_results[,2,1,1]==pop)
	boxplot(t(summ_results[these_rows[1:19],foc_all,1,]),ylim=c(-.1,1))
	boxplot(t(summ_results_2[these_rows[1:19],foc_all,1,]),add=T,col="red")
	#downside here is I didn't sample at every tree-pop combo so not comparable
	#potential issue of best populations simply being largest?
	for (i in 1:length(these_rows)) text(i,-.1,round(all_mean[these_rows[i],1]-all_mean_2[these_rows[i],1],2),cex=.5)
}
dev.off()

	###################################################	
	#PLOT FOR DIVERSITY VS. NUMBER OF TREES- SCATTERPLOT- FOR PUBLICATION
	
#Further emphasizing that the "best" is better than random, this will plot diversity vs. number of trees
pdf(file=paste("scatterplot_best_random_all_samples.pdf"), width=6,height=6)
plot(summ_results[1:190,3,1,1:50]~summ_results[1:190,1,1,1:50],pch=16, col=rgb(0,0,0,.5), xlab="number of individuals treated", ylab="proportion of all alleles preserved")
points(summ_results_2[1:190,3,1,1:50]~summ_results_2[1:190,1,1,1:50], pch=16, col=rgb(1,0,0,.3))
legend(125,.4,legend=c("optimal choice", "random choice"),col=c("red","black"),pch=16)
dev.off()

(lm((c(summ_results[1:10,3,1,1:100])~c(summ_results[1:10,1,1,1:100]))))
(lm((c(summ_results_2[1:10,3,1,1:100])~c(summ_results_2[1:10,1,1,1:100]))))




